using Raven.Client.Connection;
using Raven.Client.Document;

namespace Raven.Client.Linq
{
	///<summary>
	/// Generate a new document query
	///</summary>
	public interface IDocumentQueryGenerator
	{
		/// <summary>
		/// Gets the conventions associated with this query
		/// </summary>
		DocumentConvention Conventions { get; }

		/// <summary>
		/// Create a new query for <typeparam name="T"/>
		/// </summary>
		IDocumentQuery<T> Query<T>(string indexName, bool isMapReduce);

		/// <summary>
		/// Create a new query for <typeparam name="T"/>
		/// </summary>
		IAsyncDocumentQuery<T> AsyncQuery<T>(string indexName, bool isMapReduce);

	    /// <summary>
	    /// Generates a query inspector
	    /// </summary>
	    /// <returns>RavenQueryInspector object</returns>
	    RavenQueryInspector<S> CreateRavenQueryInspector<S>();
	}

}